Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.geometry.partitioning
Class AbstractRegion<S extends Space,T extends Space>

    java.lang.Object
      org.apache.commons.math3.geometry.partitioning.AbstractRegion<S,T>

Type Parameters:
  `S` - Type of the space.
  `T` - Type of the sub-space.

All Implemented Interfaces:
  Region<S>

Direct Known Subclasses:
  IntervalsSet, PolygonsSet, PolyhedronsSet

    public abstract class AbstractRegion<S extends Space,T extends Space>

extends Object
implements Region<S>

Abstract class for all regions, independently of geometry type or dimension.

Since:
  3.0
Version:
  $Id: AbstractRegion.java 1416643 2012-12-03 19:37:14Z tn $

Nested Class Summary

Nested classes/interfaces inherited from interface org.apache.commons.math3.geometry.partitioning.Region
`Region.Location`

Constructor Summary
`protected` | `AbstractRegion()` Build a region representing the whole space.
`protected` | `AbstractRegion(BSPTree<S> tree)` Build a region from an inside/outside BSP tree.
`protected` | `AbstractRegion(Collection<SubHyperplane<S>> boundary)` Build a Region from a Boundary REPresentation (B-rep).
`` | `AbstractRegion(Hyperplane<S>[] hyperplanes)` Build a convex region from an array of bounding hyperplanes.

Method Summary
`AbstractRegion<S,T>` | `applyTransform(Transform<S,T> transform)` Transform a region.
`abstract AbstractRegion<S,T>` | `buildNew(BSPTree<S> newTree)` Build a region using the instance as a prototype.
`protected Region.Location` | `checkPoint(BSPTree<S> node, Vector<S> point)` Check a point with respect to the region starting at a given node.
`Region.Location` | `checkPoint(Vector<S> point)` Check a point with respect to the region.
`protected abstract void` | `computeGeometricalProperties()` Compute some geometrical properties.
`boolean` | `contains(Region<S> region)` Check if the instance entirely contains another region.
`AbstractRegion<S,T>` | `copySelf()` Copy the instance.
`Vector<S>` | `getBarycenter()` Get the barycenter of the instance.
`double` | `getBoundarySize()` Get the size of the boundary.
`double` | `getSize()` Get the size of the instance.
`BSPTree<S>` | `getTree(boolean includeBoundaryAttributes)` Get the underlying BSP tree.
`SubHyperplane<S>` | `intersection(SubHyperplane<S> sub)` Get the parts of a sub-hyperplane that are contained in the region.
`boolean` | `isEmpty()` Check if the instance is empty.
`boolean` | `isEmpty(BSPTree<S> node)` Check if the sub-tree starting at a given node is empty.
`protected void` | `setBarycenter(Vector<S> barycenter)` Set the barycenter of the instance.
`protected void` | `setSize(double size)` Set the size of the instance.
`Side` | `side(Hyperplane<S> hyperplane)` Compute the relative position of the instance with respect to an hyperplane.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AbstractRegion

    protected AbstractRegion()

  Build a region representing the whole space.

### AbstractRegion

    protected AbstractRegion(BSPTree<S> tree)

  Build a region from an inside/outside BSP tree.

  The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

  Parameters:
    `tree` - inside/outside BSP tree representing the region

### AbstractRegion

    protected AbstractRegion(Collection<SubHyperplane<S>> boundary)

  Build a Region from a Boundary REPresentation (B-rep).

  The boundary is provided as a collection of `sub-hyperplanes`. Each sub-hyperplane has the interior part of the region on its minus side and the exterior on its plus side.

  The boundary elements can be in any order, and can form several non-connected sets (like for example polygons with holes or a set of disjoints polyhedrons considered as a whole). In fact, the elements do not even need to be connected together (their topological connections are not used here). However, if the boundary does not really separate an inside open from an outside open (open having here its topological meaning), then subsequent calls to the `checkPoint` method will not be meaningful anymore.

  If the boundary is empty, the region will represent the whole space.

  Parameters:
    `boundary` - collection of boundary elements, as a collection of `SubHyperplane` objects

### AbstractRegion

    public AbstractRegion(Hyperplane<S>[] hyperplanes)

  Build a convex region from an array of bounding hyperplanes.

  Parameters:
    `hyperplanes` - array of bounding hyperplanes (if null, an empty region will be built)

Method Detail

### buildNew

    public abstract AbstractRegion<S,T> buildNew(BSPTree<S> newTree)

  Build a region using the instance as a prototype.

  This method allow to create new instances without knowing exactly the type of the region. It is an application of the prototype design pattern.

  The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

  Specified by:
    `buildNew` in interface `Region<S extends Space>`
  Parameters:
    `newTree` - inside/outside BSP tree representing the new region
  Returns:
    the built region

### copySelf

    public AbstractRegion<S,T> copySelf()

  Copy the instance.

  The instance created is completely independant of the original one. A deep copy is used, none of the underlying objects are shared (except for the underlying tree `Boolean` attributes and immutable objects).

  Specified by:
    `copySelf` in interface `Region<S extends Space>`
  Returns:
    a new region, copy of the instance

### isEmpty

    public boolean isEmpty()

  Check if the instance is empty.

  Specified by:
    `isEmpty` in interface `Region<S extends Space>`
  Returns:
    true if the instance is empty

### isEmpty

    public boolean isEmpty(BSPTree<S> node)

  Check if the sub-tree starting at a given node is empty.

  Specified by:
    `isEmpty` in interface `Region<S extends Space>`
  Parameters:
    `node` - root node of the sub-tree (must have `Region` tree semantics, i.e. the leaf nodes must have `Boolean` attributes representing an inside/outside property)
  Returns:
    true if the sub-tree starting at the given node is empty

### contains

    public boolean contains(Region<S> region)

  Check if the instance entirely contains another region.

  Specified by:
    `contains` in interface `Region<S extends Space>`
  Parameters:
    `region` - region to check against the instance
  Returns:
    true if the instance contains the specified tree

### checkPoint

    public Region.Location checkPoint(Vector<S> point)

  Check a point with respect to the region.

  Specified by:
    `checkPoint` in interface `Region<S extends Space>`
  Parameters:
    `point` - point to check
  Returns:
    a code representing the point status: either `Region.Location.INSIDE`, `Region.Location.OUTSIDE` or `Region.Location.BOUNDARY`

### checkPoint

    protected Region.Location checkPoint(BSPTree<S> node,
                                         Vector<S> point)

  Check a point with respect to the region starting at a given node.

  Parameters:
    `node` - root node of the region
    `point` - point to check
  Returns:
    a code representing the point status: either `INSIDE`, `OUTSIDE` or `BOUNDARY`

### getTree

    public BSPTree<S> getTree(boolean includeBoundaryAttributes)

  Get the underlying BSP tree.

  Regions are represented by an underlying inside/outside BSP tree whose leaf attributes are `Boolean` instances representing inside leaf cells if the attribute value is `true` and outside leaf cells if the attribute is `false`. These leaf attributes are always present and guaranteed to be non null.

  In addition to the leaf attributes, the internal nodes which correspond to cells split by cut sub-hyperplanes may contain `BoundaryAttribute` objects representing the parts of the corresponding cut sub-hyperplane that belong to the boundary. When the boundary attributes have been computed, all internal nodes are guaranteed to have non-null attributes, however some `BoundaryAttribute` instances may have their `plusInside` and `plusOutside` fields both null if the corresponding cut sub-hyperplane does not have any parts belonging to the boundary.

  Since computing the boundary is not always required and can be time-consuming for large trees, these internal nodes attributes are computed using lazy evaluation only when required by setting the `includeBoundaryAttributes` argument to `true`. Once computed, these attributes remain in the tree, which implies that in this case, further calls to the method for the same region will always include these attributes regardless of the value of the `includeBoundaryAttributes` argument.

  Specified by:
    `getTree` in interface `Region<S extends Space>`
  Parameters:
    `includeBoundaryAttributes` - if true, the boundary attributes at internal nodes are guaranteed to be included (they may be included even if the argument is false, if they have already been computed due to a previous call)
  Returns:
    underlying BSP tree
  See Also:
    `BoundaryAttribute`

### getBoundarySize

    public double getBoundarySize()

  Get the size of the boundary.

  Specified by:
    `getBoundarySize` in interface `Region<S extends Space>`
  Returns:
    the size of the boundary (this is 0 in 1D, a length in 2D, an area in 3D ...)

### getSize

    public double getSize()

  Get the size of the instance.

  Specified by:
    `getSize` in interface `Region<S extends Space>`
  Returns:
    the size of the instance (this is a length in 1D, an area in 2D, a volume in 3D ...)

### setSize

    protected void setSize(double size)

  Set the size of the instance.

  Parameters:
    `size` - size of the instance

### getBarycenter

    public Vector<S> getBarycenter()

  Get the barycenter of the instance.

  Specified by:
    `getBarycenter` in interface `Region<S extends Space>`
  Returns:
    an object representing the barycenter

### setBarycenter

    protected void setBarycenter(Vector<S> barycenter)

  Set the barycenter of the instance.

  Parameters:
    `barycenter` - barycenter of the instance

### computeGeometricalProperties

    protected abstract void computeGeometricalProperties()

  Compute some geometrical properties.

  The properties to compute are the barycenter and the size.

### side

    public Side side(Hyperplane<S> hyperplane)

  Compute the relative position of the instance with respect to an hyperplane.

  Specified by:
    `side` in interface `Region<S extends Space>`
  Parameters:
    `hyperplane` - reference hyperplane
  Returns:
    one of `Side.PLUS`, `Side.MINUS`, `Side.BOTH` or `Side.HYPER` (the latter result can occur only if the tree contains only one cut hyperplane)

### intersection

    public SubHyperplane<S> intersection(SubHyperplane<S> sub)

  Get the parts of a sub-hyperplane that are contained in the region.

  The parts of the sub-hyperplane that belong to the boundary are not included in the resulting parts.

  Specified by:
    `intersection` in interface `Region<S extends Space>`
  Parameters:
    `sub` - sub-hyperplane traversing the region
  Returns:
    filtered sub-hyperplane

### applyTransform

    public AbstractRegion<S,T> applyTransform(Transform<S,T> transform)

  Transform a region.

  Applying a transform to a region consist in applying the transform to all the hyperplanes of the underlying BSP tree and of the boundary (and also to the sub-hyperplanes embedded in these hyperplanes) and to the barycenter. The instance is not modified, a new instance is built.

  Parameters:
    `transform` - transform to apply
  Returns:
    a new region, resulting from the application of the transform to the instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.